package com.ibm;

import javax.swing.JFrame;
import java.awt.BorderLayout;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import javax.swing.JPanel;
import javax.swing.WindowConstants;

import com.ibm.calendar.Calendar;
import com.ibm.clock.IClock;
import javax.swing.JComponent;
import javax.swing.BoxLayout;
import java.awt.Graphics;
import java.awt.Color;
import java.net.URL;
import java.awt.image.ImageProducer;
import java.awt.Image;

import ij.plugin.frame.PlugInFrame;
import java.awt.Insets;
import javax.swing.border.BevelBorder;
import javax.swing.border.Border;
import javax.swing.BorderFactory;
import java.applet.Applet;
import javax.swing.JWindow;
import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import ij.WindowManager;
import ij.gui.GUI;
import ij.IJ;
import ij.ImageJ;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2008</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class JCalendar extends PlugInFrame implements WindowListener{
    private Calendar calendar;
    private IClock analogClock, digitalClock;
    private BevelBorder bb ;//new BevelBorder for LOWER or RAISED type
    private Border grayBorder = BorderFactory.createBevelBorder(bb.RAISED, Color.gray, Color.lightGray);
    private ImageJ ij;


    public JCalendar() {
        super("JCalendar");
    }

    /*public JCalendar(Applet applet) {
        super("");
    }*/
    public void run(String arg){
        try {
          jbInit();
      } catch (Exception ex) {
          ex.printStackTrace();
      }
  }

    private void jbInit() throws Exception {
        final JWindow palette = new JWindow(this);
        Container wcontainer = palette.getContentPane();
        wcontainer.setLayout(new GridBagLayout());

        GridBagConstraints c = new GridBagConstraints();
        analogClock = new IClock();
        calendar = new Calendar();
        JPanel cpanel = new CalendarPanel();
        cpanel.setLayout(new BorderLayout());
        cpanel.setBackground(Color.white);
        cpanel.add(calendar, BorderLayout.CENTER);
        cpanel.setBorder(grayBorder);
        digitalClock= new IClock();
        digitalClock.setDisplayMode(IClock.DIGITAL);
        digitalClock.setDigitalTwelveHourMode(false);
        analogClock.setDisplayMode(IClock.ANALOG);
        analogClock.setAnalogSecondHandColor(new Color(222, 150, 253));
        analogClock.setAnalogMinuteHandColor(new Color(122, 150, 213));
        analogClock.setAnalogHourHandColor(new Color(122, 150, 243));
        analogClock.setAnalogBorderColor(Color.lightGray);
        analogClock.setAnalogTickColor(new Color(0, 128, 0));
        CalendarClock cac = new CalendarClock();
        ClockClock cc = new ClockClock();

        //cc.setLayout(new BorderLayout());
        cc.add(analogClock);
        cc.add(digitalClock);
        //cac.setBackground(new Color(0, 48, 98));
        cac.add(cpanel);
        cac.add(cc);
        this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
        //this.getContentPane().add(calendar, java.awt.BorderLayout.WEST);
        //this.getContentPane().add(clock, java.awt.BorderLayout.EAST);
        container.add(cac);
        this.addWindowListener(this);
        this.setResizable(false);
        //setIcon();
        WindowManager.addWindow(this);
        ij = IJ.getInstance();
        GUI.relRight(ij, this);
        pack();
        this.setVisible(true);
    }
    void setIcon() {
        String dir = "/images/";
        //String name = "microscope~.gif";
        String name = "clock1.png";
        //String name = "eclipse1.png";
        //String name = "eclipse_17.gif";
        String path=dir+name;

        URL url = this.getClass().getResource(path);
            if (url==null)
                    return;
            Image img = null;
            try {img = createImage((ImageProducer)url.getContent());}
            catch(Exception e) {}
            if (img!=null)
                    try {setIconImage(img);} catch (Exception e) {}
    }
    /**
     * FIXME - I'm not very useful yet
     */
    /**/public class CalendarClock extends JComponent {

        public CalendarClock() {
            super();
            setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
        }
        /** Override Container getInsets() to make room for some text above the image. */
        public Insets getInsets() {
                Insets insets = super.getInsets();
                int offsetTop = 5;
                int offsetBottm = 5;
                int offsetLeft = 5;
                int offsetRight = 5;
                insets = new Insets(insets.top+offsetTop, insets.left+offsetLeft, insets.bottom+offsetBottm, insets.right+offsetRight);
                return insets;
        }


        public void paint(Graphics g) {
            super.paint(g);
        }

    }
    /**
     * FIXME - I'm not very useful yet
     */
    /**/public class ClockClock extends JComponent {

        public ClockClock() {
            super();
            setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        }

        /** Override Container getInsets() to make room for some text above the image. */
        public Insets getInsets() {
                Insets insets = super.getInsets();
                int offsetTop = 0;
                int offsetBottm = 0;
                int offsetLeft = 0;
                int offsetRight = 0;
                insets = new Insets(insets.top+offsetTop, insets.left+offsetLeft, insets.bottom+offsetBottm, insets.right+offsetRight);
                return insets;
        }

        public void paint(Graphics g) {
            super.paint(g);
        }

    }
    /**
     * FIXME - I'm not very useful yet
     */
    /**/public class CalendarPanel extends JPanel {

        public CalendarPanel() {
            super();
            //setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
        }

        /** Override Container getInsets() to make room for some text above the image. */
        public Insets getInsets() {
            Insets insets = super.getInsets();
            int offsetTop = 5;
            int offsetBottm = 0;
            int offsetLeft = 5;
            int offsetRight = 0;
            insets = new Insets(insets.top + offsetTop, insets.left + offsetLeft,
                                insets.bottom + offsetBottm,
                                insets.right + offsetRight);
            return insets;
        }
        public void update(Graphics g) {
            paint(g);
        }
        public void paint(Graphics g) {
            super.paint(g);
        }
}

    public void windowClosing(WindowEvent e) {
                    setVisible(false);
                    calendar.stop();
                    dispose();
                    WindowManager.removeWindow(this);
                    GUI.cwl--;
   }
    public void windowActivated(WindowEvent e) {
        WindowManager.setWindow(this);
    }
    public void windowClosed(WindowEvent e) {}
    public void windowDeactivated(WindowEvent e) {}
    public void windowDeiconified(WindowEvent e) {}
    public void windowIconified(WindowEvent e) {}
    public void windowOpened(WindowEvent e) {}


    public static void main(String[] args) {
       //JCalendar frame = new JCalendar();
   }
}
