package ij2x.plugin;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.GridBagLayout;
import java.awt.Color;
import java.awt.Image;
import java.util.MissingResourceException;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.border.BevelBorder;
import javax.swing.BorderFactory;
import javax.swing.border.Border;

import ij.IJ;
import ij.ImageJ;
import ij.ImagePlus;
import ij.plugin.PlugIn;

import ij2x.util.ResourceString;
import ij2x.util.BorderlessButton;
import ij2x.util.AWTImages;
import ij2x.util.ImageIcons;


/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2012</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class MathPanel extends JPanel implements PlugIn, ActionListener, MouseListener, MouseMotionListener {

    protected ImagePlus imp;
    protected ImageJ ij;
    public JButton infoButton, draggedButton, closeButton, undecoratedButton;
    protected JButton addButton, subButton, mulButton, divButton, orButton, andButton
            , xorButton, minButton, maxButton, gammaButton, calculButton ;
    private JButton action;
    private BevelBorder bb ;//new BevelBorder for LOWER or RAISED type
    private Border lightGrayBorder = BorderFactory.createBevelBorder(bb.RAISED, Color.lightGray, Color.lightGray);
    private int actionCount = 0;
    private static int current;
    private long mouseDownTime;
    public static final int DOUBLE_CLICK_THRESHOLD = 150;
    public JPanel controlBarPanel=new JPanel();
    public JPanel panel=new JPanel();
    private GridBagLayout gblayout = new GridBagLayout();

    private static ResourceBundle resources;
    private int index = 0;

    static {
        try {
            resources = ResourceBundle.getBundle("ij2x.plugin.resources.MathBar",
                                                 Locale.getDefault());
        } catch (MissingResourceException mre) {
            System.err.println("resources/MathBar.properties not found");
            System.exit(1);
        }
    }
    public MathPanel() {
    }
    public void run(String arg){
        ij = IJ.getInstance();
        controlBarPanel=createControlBar();
    }

    public JPanel createControlBar(){

        java.awt.FlowLayout flayout = new java.awt.FlowLayout(java.awt.FlowLayout.LEFT);
        flayout.setHgap(0);
        flayout.setVgap(0);
        panel.setLayout(flayout);
        panel.setBorder(lightGrayBorder);

        ImageIcon b1o = ImageIcons.getIcons(this);

        AWTImages.setImageDir("mathDir");


    String[] iconAllName = ResourceString.tokenize(ResourceString.getResourceString(resources, "mathbar"));

    Image[][] icons = new Image[iconAllName.length][3];
    for(int i=0; i < iconAllName.length; i++){
        for(int j=0; j < 3; j++){
            icons[i][j]=((ImageIcon)AWTImages.createBufferedIcon(
                    this
                      , ResourceString.tokenize(ResourceString.getResourceString(resources, iconAllName[i]))[j]
                        , b1o.getImage()
                          , 24)).getImage();
        }
    }

        addButton=BorderlessButton.createButton(this, addButton, "Add Dyadic Image", icons[index++]);

        subButton=BorderlessButton.createButton(this, subButton, "Sub Dyadic Image", icons[index++]);

        mulButton=BorderlessButton.createButton(this, mulButton, "Mul Dyadic Image", icons[index++]);

        divButton=BorderlessButton.createButton(this, divButton, "Div Dyadic Image", icons[index++]);

        minButton=BorderlessButton.createButton(this, minButton, "Min Dyadic Image", icons[index++]);

        maxButton=BorderlessButton.createButton(this, maxButton, "Max Dyadic Image", icons[index++]);

        gammaButton=BorderlessButton.createButton(this, gammaButton, "Gamma Image", icons[index++]);

        orButton=BorderlessButton.createButton(this, orButton, "Or Dyadic Image", icons[index++]);

        andButton=BorderlessButton.createButton(this, andButton, "And Dyadic Image", icons[index++]);

        xorButton=BorderlessButton.createButton(this, xorButton, "Xor Image", icons[index++]);

        calculButton=BorderlessButton.createButton(this, calculButton, "Image Calculator", icons[index++]);

        infoButton=BorderlessButton.createButton(this, infoButton, "Show Info ...", icons[index]);


        panel.add(calculButton);
        panel.add(addButton);
        panel.add(subButton);
        panel.add(mulButton);
        panel.add(divButton);
        panel.add(andButton);
        panel.add(orButton);
        panel.add(xorButton);
        panel.add(minButton);
        panel.add(maxButton);
        panel.add(gammaButton);
        panel.add(infoButton);

        return panel;
     }

       public void mousePressed(MouseEvent e) {
           action = (JButton)e.getSource();
           int x = e.getX();
           boolean doubleClick = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
           mouseDownTime = System.currentTimeMillis();
                if (!doubleClick) {
                }
        }

        public void mouseReleased(MouseEvent e) {}
        public void mouseExited(MouseEvent e) {}
        public void mouseClicked(MouseEvent e) {}
        public void mouseEntered(MouseEvent e) {}

        public void mouseDragged(MouseEvent e) {}
        public void mouseMoved(MouseEvent e) {
            JButton action = (JButton)e.getSource();
            int x = e.getX();
            boolean doubleClick = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
            mouseDownTime = System.currentTimeMillis();
                 if (!false) {
                     if(action == infoButton){
                         IJ.showStatus("Command: Show Info...");
                     }
                     else if(action == addButton){
                         IJ.showStatus("Command: Add...");
                     }
                     else if(action == subButton){
                         IJ.showStatus("Command: Sub...");
                     }
                     else if(action == mulButton){
                         IJ.showStatus("Command: Mul...");
                     }
                     else if(action == divButton){
                         IJ.showStatus("Command: Div...");
                     }
                     else if(action == andButton){
                         IJ.showStatus("Command: And...T");
                     }
                     else if(action == orButton){
                         IJ.showStatus("Command: Or...");
                     }
                     else if(action == xorButton){
                         IJ.showStatus("Command: Xor...");
                     }
                     else if(action == minButton){
                         IJ.showStatus("Command: Min...");
                     }
                     else if(action == maxButton){
                         IJ.showStatus("Command: Max...");
                     }
                     else if (action == draggedButton) {
                         IJ.showStatus("Move...");
                     }
                     else if (action == closeButton) {
                         IJ.showStatus("Decorated Frame");
                     }
                     else if (action == undecoratedButton) {
                         IJ.showStatus("Undecorated Frame");
                     }
                     else if(action == gammaButton){
                         IJ.showStatus("Command: Gamma...");
                     }
                     else if(action == calculButton){
                         IJ.showStatus("Command: ImageCalculator...");
                     }

                 }
        }
        public void actionPerformed(ActionEvent e){
            try {
                if(action == infoButton){
                    IJ.doCommand("Show Info...");
                }
                else if(action == addButton){
                    IJ.runPlugIn("ij.plugin.filter.ImageMath", "add");
                }
                else if(action == subButton){
                    IJ.runPlugIn("ij.plugin.filter.ImageMath", "sub");
                }
                else if(action == mulButton){
                    IJ.runPlugIn("ij.plugin.filter.ImageMath", "mul");
                }
                else if(action == divButton){
                    IJ.runPlugIn("ij.plugin.filter.ImageMath", "div");
                }
                else if(action == andButton){
                    IJ.runPlugIn("ij.plugin.filter.ImageMath", "and");
                }
                else if(action == orButton){
                    IJ.runPlugIn("ij.plugin.filter.ImageMath", "or");
                }
                else if(action == xorButton){
                    IJ.runPlugIn("ij.plugin.filter.ImageMath", "xor");
                }
                else if(action == minButton){
                    IJ.runPlugIn("ij.plugin.filter.ImageMath", "min");
                }
                else if(action == maxButton){
                    IJ.runPlugIn("ij.plugin.filter.ImageMath", "max");
                }
                else if(action == gammaButton){
                    IJ.runPlugIn("ij.plugin.filter.ImageMath", "gamma");
                }
                else if(action == calculButton){
                    IJ.runPlugIn("ij.plugin.ImageCalculator", "");
               }
           } catch (Exception ex) {

            }
        }
}
